Bug 982786 - Pulseaudio sets mic boost to 0, internal microphone unusable
Pulseaudio sets mic boost to 0, internal microphone unusable
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: pulseaudio (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Lennart Poettering
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-09 17:51 EDT by James
Modified: 2014-09-28 17:41 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-09-28 17:41:12 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
alsa-info (27.69 KB, text/plain)
2013-07-09 17:51 EDT, James
no flags Details
pulseaudio -vvvv output (144.96 KB, text/plain)
2013-07-16 17:32 EDT, James
no flags Details

  None (edit)
Description James 2013-07-09 17:51:17 EDT
Created attachment 771281 [details]
alsa-info

Description of problem:
The internal microphone on my notebook needs the mic boost set in the mixer or else no sound is recorded from it. As this is set to 0 from install, I can set this using alsamixer, but switching the input between "Analog Input" and "Internal Microphone" in Sound Settings results in the mic boost being reset to 0. Killing and restarting PA has the same effect -- mic boost set to 0.

This seems to be a regression from Fedora 17, I don't remember having to [repeatedly] go into alsamixer and adjust mic boost back then. [Not sure whether ALSA or PA is at fault here.]

Version-Release number of selected component (if applicable):
alsa-lib-1.0.27.1-2.fc19.x86_64
pulseaudio-3.0-10.fc19.x86_64
kernel-3.9.9-301.fc19.x86_64

How reproducible:
Always.

Steps to Reproduce:
1. Open GNOME Sound Settings, go to Input tab.
2. Select the Internal Microphone as the input.
3. Run alsamixer -c0 to observe settings. Ensure that mic boost is set > 0 so that sounds register on the Sound Settings meter. 
4. Back in Sound Settings, select Analog Input as input, then the microphone again.

Actual results:
Mic boost has dropped to 0. No audio recorded from internal microphone.

Expected results:
Mic boost setting preserved, or kept to a sensible level.

Additional info:
Output of alsa-info.sh attached.
Comment 1 Raymond 2013-07-14 05:23:51 EDT
seem auto Mic is enabled when there are only internal mic and Mic jack


did pulseaudio expect to find internal Mic boot ?

post the pulseaudio verbose log when you plugged and unplugged extra mic

pulseaudio -vvvv


Node 0x14 [Audio Input] wcaps 0x100d1b: Stereo Amp-In R/L
  Control: name="Capture Volume", index=0, device=0
    ControlAmp: chs=3, dir=In, idx=0, ofs=0
  Control: name="Capture Switch", index=0, device=0
    ControlAmp: chs=3, dir=In, idx=0, ofs=0
  Device: name="CX20585 Analog", type="Audio", device=0
  Amp-In caps: ofs=0x4a, nsteps=0x50, stepsize=0x03, mute=1
  Amp-In vals:  [0x4a 0x4a] [0x80 0x80] [0x80 0x80] [0x80 0x80]
  Converter: stream=4, channel=0
  SDI-Select: 0
  PCM:
    rates [0x160]: 44100 48000 96000
    bits [0xe]: 16 20 24
    formats [0x1]: PCM
  Power states:  D0 D1 D2 D3 D3cold
  Power: setting=D0, actual=D0
  Connection: 4
     0x17* 0x18 0x23 0x24

Node 0x17 [Audio Selector] wcaps 0x30050d: Stereo Amp-Out
  Control: name="Mic Boost Volume", index=0, device=0
    ControlAmp: chs=3, dir=Out, idx=0, ofs=0
  Amp-Out caps: ofs=0x00, nsteps=0x04, stepsize=0x27, mute=0
  Amp-Out vals:  [0x03 0x03]
  Power states:  D0 D1 D2 D3 D3cold
  Power: setting=D0, actual=D0
  Connection: 4
     0x1a* 0x1b 0x1d 0x1e
Node 0x18 [Audio Selector] wcaps 0x30050d: Stereo Amp-Out
  Amp-Out caps: ofs=0x00, nsteps=0x04, stepsize=0x27, mute=0
  Amp-Out vals:  [0x00 0x00]
  Power states:  D0 D1 D2 D3 D3cold
  Power: setting=D0, actual=D0
  Connection: 4
     0x1a* 0x1b 0x1d 0x1e

Node 0x1a [Pin Complex] wcaps 0x400481: Stereo
  Control: name="Internal Mic Phantom Jack", index=0, device=0
  Pincap 0x00001324: IN Detect
    Vref caps: HIZ 50 80
  Pin Default 0x90a70120: [Fixed] Mic at Int N/A
    Conn = Analog, Color = Unknown
    DefAssociation = 0x2, Sequence = 0x0
    Misc = NO_PRESENCE
  Pin-ctls: 0x24: IN VREF_80
  Unsolicited: tag=00, enabled=0
  Power states:  D0 D1 D2 D3 D3cold
  Power: setting=D0, actual=D0
Node 0x1b [Pin Complex] wcaps 0x400581: Stereo
  Control: name="Mic Jack", index=0, device=0
  Pincap 0x00011334: IN OUT EAPD Detect
    Vref caps: HIZ 50 80
  EAPD 0x2: EAPD
  Pin Default 0x04a11030: [Jack] Mic at Ext Right
    Conn = 1/8, Color = Black
    DefAssociation = 0x3, Sequence = 0x0
  Pin-ctls: 0x24: IN VREF_80
  Unsolicited: tag=02, enabled=1
  Power states:  D0 D1 D2 D3 D3cold
  Power: setting=D0, actual=D0
  Connection: 2
     0x10* 0x11
Comment 2 Raymond 2013-07-14 05:30:24 EDT
http://cgit.freedesktop.org/pulseaudio/pulseaudio/tree/src/modules/alsa/mixer/paths/analog-input-internal-mic.conf 

the work around may be keep Mic boost on instead of off
Comment 3 James 2013-07-16 17:32:11 EDT
(In reply to Raymond from comment #1)
> seem auto Mic is enabled when there are only internal mic and Mic jack
> 
> 
> did pulseaudio expect to find internal Mic boot ?
> 
> post the pulseaudio verbose log when you plugged and unplugged extra mic

This notebook has an external microphone jack, but nothing is plugged into it. The internal microphone appears to work OK once the mic boost is enabled.

I have attached a pulseaudio -vvvv log. After starting pulseaudio, I turned the mic boost up a bit in alsamixer, then switched to "Analog Input" and back to the internal microphone as described earlier.

I'll give the suggested patch a go.
Comment 4 James 2013-07-16 17:32:50 EDT
Created attachment 774507 [details]
pulseaudio -vvvv output
Comment 5 James 2013-07-16 18:28:25 EDT
(In reply to Raymond from comment #2)
> http://cgit.freedesktop.org/pulseaudio/pulseaudio/tree/src/modules/alsa/
> mixer/paths/analog-input-internal-mic.conf 
> 
> the work around may be keep Mic boost on instead of off

Using the linked .conf file, PA leaves the mic boost alone. There is only one input device present, "Analog Input - Built-In Audio". I don't have my headset to hand right now to test whether another device appears when a microphone is plugged in. I'll let you know when I've tested it.
Comment 6 James 2014-09-28 17:41:12 EDT
I'll close this and create a new bug as I've now moved to F21.

Note You need to log in before you can comment on or make changes to this bug.